mod common;
mod error;
mod formats;
mod linker;

use std::path::PathBuf;

use linker::Linker;

fn main() {
    let mut args = std::env::args().peekable();

    // can this miss?
    args.next().unwrap();

    let destination = PathBuf::new(); // TODO
    let mut linker = Linker::elf(destination).expect("Linker init");

    while args.peek().is_some() {
        let path = PathBuf::from(args.next().expect("Argument expansion"));

        linker.add_relocatable(path);
    }

    let outpath = linker.link().expect("Linking");
    eprintln!("Done {:?}", outpath);
}
